/*
* $Id: psp2chMenu.c 148 2008-08-27 06:31:27Z bird_may_nike $
*
* 2010-05-31 STEAR BGMt@C[֘AC
*/

#include "FreezeViewer.h"
#include "psp2ch.h"
#include <psputility.h>
#include <psppower.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "psp2chIni.h"
#include "psp2chMenu.h"
#include "psp2chImageView.h"
#include "psp2chAudio.h"
#include "charConv.h"
#include "fvDraw.h"
#include "psp2chError.h"
#include "pspdialogs.h"
#include "intraFont.h"
#include "message.h"

//----- 萔ݒ -----

#define FONTPITCH			(24)								// Xg̍s
#define MENU_MP3FILE_ITEM	(10)								// Xg̍s

//----- OQ -----

extern S_2CH s2ch; // psp2ch.c
extern char keyWords[128]; //psp2ch.c

//------ O[oϐ -----


//----- vg^Cv錾 -----

static int psp2chMenuGetDir(char* file, DirList **DList);
static int psp2chMenuFileCtrl(char* path, char* name, int status);

int	SMEMOfile(char *path);										// PSP


/****************
j[EBhE`
****************/
static void psp2chDrawMenu(char** menuList, int x, int y, int width, int height)
{
    int i, start, lineEnd;
/*
    lineEnd = height / LINE_PITCH;
    start = menu.start;
    if (start + lineEnd > menu.count)
    {
        start = menu.count - lineEnd;
    }
    if (start < 0)
    {
        start = 0;
    }
    pgFillvram(0, 0, 0, BUF_WIDTH, BUF_HEIGHT, 2);
    pgFillvram(s2ch.menuWinColor.bg, x, y, width, height, 2);
    for (i = start; i < start + lineEnd; i++)
    {
        if (i >= menu.count)
        {
            return;
        }
        if (i == menu.select)
        {
            pgFillvram(s2ch.menuWinColor.s_bg, x, winParam->pgCursorY, width, LINE_PITCH, 2);
            pgPrint(menuList[i], s2ch.menuWinColor.s_text, s2ch.menuWinColor.s_bg, x + width);
        }
        else
        {
            pgPrint(menuList[i], s2ch.menuWinColor.text, s2ch.menuWinColor.bg, x + width);
        }
    }
*/
}

//==============================================================
// fBNgXg̍폜
//--------------------------------------------------------------

static void deleteDirList(DirList **DListPtr)
{
	DirList	*DList;
	int		i;

	DList = *DListPtr;
	for (i = 0; i < DList->count; i++)
	{
		free(DList->file[i].name);
		DrawImgFree(DList->file[i].thumb);
	}
	free(DList->file);
	DList->count = 0;
	DList->pos = 0;
}

//==============================================================
// \
//--------------------------------------------------------------

void statusDraw(int reset)
{
	char	str[256], buf[32];
	int		battery, w;
	pspTime	time;
	static float	x_scroll1;
	static char		bgmFileBak[FILE_PATH], bgmFileUtf8[FILE_PATH];

	if (sceRtcGetCurrentClockLocalTime(&time) < 0) {			// 
		strcpy( str, "--/-- --:--" );
	} else {
		sprintf( str, "%d/%d %d:%02d", time.month, time.day, time.hour, time.minutes );
	}
	battery = scePowerGetBatteryLifePercent();					// obe[
	if (battery < 0) {
		strcat( str, "  ---%" );
	} else {
		sprintf( buf, "  %d%%", battery );
		strcat( str, buf );
	}
	intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
	w = intraFontMeasureText( gJpn0, str );
	if_print( 475-w, 16, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f );

	if (reset!=1 && strlen(s2ch.bgmFile)) {						// BGMt@C
		if (strcmp(bgmFileBak, s2ch.bgmFile)!=0) {				// BGMς
			strcpy( bgmFileBak, s2ch.bgmFile );
			psp2chSjis2UTF8( bgmFileUtf8, bgmFileBak );
			x_scroll1 = 300;
		}
		intraFontSetStyle( gJpn0, 0.7f, 0xC0FFFFFF, 0xC0404040, INTRAFONT_SCROLL_LEFT );
		x_scroll1 = intraFontPrintColumn( gJpn0, x_scroll1, 32, 170, bgmFileUtf8 );
	} else {													// BGM~܂
		bgmFileBak[0] = '\0';
		x_scroll1 = 300;
	}
}

//==============================================================
// t@CXg\
//--------------------------------------------------------------

void ListDraw(DirList *DList, int x, int y,int alpha, int reset)
{
	static float	y2 = -1;
	static unsigned char	blink = 0;
	static int				blFlg = 1;
	float			sy;
	char			buf[256];
	int				i, x2, start, count;

	blitImageToScreen(0, 0, 480, 272, gScrBuf1, 0, 0);

	guStart();
	sceGuClear(GU_DEPTH_BUFFER_BIT);
	statusDraw(reset);

	if (DList->count == 0) {									// Xgꍇ
		if_print( x, y+12, "No Data", 0.8f, 0xC0C0FF, 0x101010, alpha/100 );
		sceGuFinish();
		return;
	}

	count = 12;
	sy = DList->pos * FONTPITCH;								// _ł̖ڕWzW
	if (reset) {
		y2 = sy;
		blink = 0;
		blFlg = 1;
	} else {
		y2 += (sy - y2) / 8;
		if (abs(sy - y2)==0) {									// ړ~
			y2 = sy;
		} else {												// ړ
			count++;											// ړ͕\鍀ڐP₷
		}
	}
	start = (y2 / FONTPITCH) - 4;								// 4:J[\ʒu
	if (start<0) {
		count -= start;
	}
	y -= y2 - start * FONTPITCH;

	if (blFlg > 0) {											// e̓_
		blink += 6;
		if (blink > 0xF8) blFlg = -blFlg;
	} else {
		blink -= 6;
		if (blink < 0x10) blFlg = -blFlg;
	}

	for (i = start; i < start + count; i++){
		if (i >= 0) {
			if (i >= DList->count){								// XgI[zȂ
				break;
			}
			if (i == DList->pos){								// J[\ʒu
				if (DList->file[i].thumb) {						// TlC摜Ȃ
					DrawPicAlpha( x-32-(DList->file[i].thumb->wx/2), y+19-(DList->file[i].thumb->wy/2), DList->file[i].thumb, 1.0f, 1.0f );
				}
				if_clipText( buf, DList->file[i].name, 370, 0.8f );
				if (DList->file[i].type == 1) {					// fBNgp
					if_print( x, y+12, buf, 0.8f, 0x00FFFF, blink/2 + ((blink/2)<<8) + (blink<<16), alpha/100 );
				} else {										// t@Cp
					if_print( x, y+12, buf, 0.8f, 0xFFFFFF, blink/2 + ((blink/2)<<8) + (blink<<16), alpha/100 );
				}
				if (alpha==100) {
					drawLineScreen( x, y+17, x+370, y+17, 0xFFFFFF );
				}
				sprintf( buf, "%04d/%02d/%02d  %d:%02d", DList->file[i].mtime.year, DList->file[i].mtime.month, DList->file[i].mtime.day
				                                       , DList->file[i].mtime.hour, DList->file[i].mtime.minute );
				x2 = if_print( x, y+30, buf, 0.6f, 0xFFFFFF, 0x101010, alpha/100 );
				if (!DList->file[i].type) {
					if (DList->file[i].size < 1024) {
						sprintf( buf, "%dB", (int)DList->file[i].size );
					} else if (DList->file[i].size < 1024 * 1024) {
						sprintf( buf, "%dKB", (int)DList->file[i].size / 1024 );
					} else {
						sprintf( buf, "%dMB", (int)DList->file[i].size / (1024 * 1024) );
					}
					x2 = if_print( x2+10, y+30, buf, 0.6f, 0xFFFFFF, 0x101010, alpha/100 );
				}
			} else {											// J[\ȊÖʒu
				if (DList->file[i].thumb) {						// TlC摜Ȃ
					DrawPicAlpha( x-32-(DList->file[i].thumb->wx*0.5f/2), y+8-(DList->file[i].thumb->wy*0.5f/2), DList->file[i].thumb, 0.7f * y / (y<=19 ? 19 : y) *alpha/100, 0.5f);
				}
				if_clipText( buf, DList->file[i].name, 370, 0.8f );
				if (DList->file[i].type == 1) {					// fBNgp
					if_print( x, y+12, buf, 0.8f, 0x00FFFF, 0x101010, 0.7f * y / (y<=19 ? 19 : y) *alpha/100 );
				} else {										// t@Cp
					if_print( x, y+12, buf, 0.8f, 0xFFFFFF, 0x101010, 0.7f * y / (y<=19 ? 19 : y) *alpha/100 );
				}
			}
		}
		if (i == DList->pos) y += FONTPITCH;
		y += FONTPITCH;
	}
	sceGuFinish();
}

//==============================================================
// gqɑΉ
//--------------------------------------------------------------

static void doFile(char *path, char *file, DirList *DList)
{
	static int	picMenu = 1, thumbFlag;
	FileData	*FData;
	char	*p, name[FILE_PATH];
	int		i, type, next, chKey;

	thumbFlag = -1;
	while (!gExitRequest){										// 摜p[v
		psp2chUTF82Sjis( name, DList->file[DList->pos].name );
		p = strrchr( name, '.' );
		type = 0;												// 0:̑ 1:摜t@C
		if(p)
		{
			FData = &DList->file[DList->pos];
			if (stricmp(p, ".mp3") == 0)
			{
				psp2chAudioPlay(path, name);
			}
			if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0)
			{
				psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 0);
				type = 1;
			}
			if (stricmp(p, ".png") == 0)
			{
				psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 1);
				type = 1;
			}
			if (stricmp(p, ".gif") == 0)
			{
				psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 2);
				type = 1;
			}
			if (stricmp(p, ".bmp") == 0)
			{
				psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 3);
				type = 1;
			}
			if (stricmp(p, ".txt") == 0 || stricmp(p, ".ini") == 0 || stricmp(p, ".cfg") == 0){
				SMEMOfile( file );								// wt@CPSPŊJ
			}
		}
		if (type && (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER ||
		             s2ch.pad.Buttons & PSP_CTRL_LTRIGGER)){	// 摜
			if (s2ch.cfg.keySwap){								// 摜L[̓ւ
				chKey = PSP_CTRL_LTRIGGER;
			} else {
				chKey = PSP_CTRL_RTRIGGER;
			}
			if (s2ch.pad.Buttons & chKey){						// ̉摜
				next = -1;
				DList->pos++;
				if (DList->pos>=DList->count) DList->pos = 0;
				while (next==-1){								// ̉摜t@CT
					for (i=DList->pos; i<DList->count; i++){
						p = strrchr( DList->file[i].name, '.' );
						if(p){
							if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0 ||
								stricmp(p, ".png") == 0 ||
								stricmp(p, ".gif") == 0 ||
								stricmp(p, ".bmp") == 0){
								next = i;
								break;
							}
						}
					}
					if (next==-1) DList->pos = 0;				// 摜Ȃΐ擪ɖ߂Ă蒼
				}
			} else {											// Ỏ摜
				next = -1;
				DList->pos--;
				if (DList->pos<0) DList->pos = DList->count -1;
				while (next==-1){								// Ỏ摜t@CT
					for (i=DList->pos; i>=0 ;i--){
						p = strrchr( DList->file[i].name, '.' );
						if(p){
							if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0 ||
								stricmp(p, ".png") == 0 ||
								stricmp(p, ".gif") == 0 ||
								stricmp(p, ".bmp") == 0){
								next = i;
								break;
							}
						}
					}
					if (next==-1) {								// 摜Ȃ΍Ōɖ߂Ă蒼
						DList->pos = DList->count - 1;
					}
				}
			}
			DList->pos = next;									// ɕ\摜
			psp2chUTF82Sjis( name, DList->file[DList->pos].name );
			strcpy( file, path );
			strcat( file, "/" );
			strcat( file, name );

		} else {
			break;												// 摜Ƃ͊֌WȂ̂Ń[vI
		}
	}

	if (type) {													// 摜\Ăꍇ͔wiޔ
		blitScreenToImage(0, 0, 480, 272, gScrBuf1, 0, 0);
	}
}

//==============================================================
// t@CXg
//--------------------------------------------------------------

int psp2chMenuPlayer(char* base)
{
	SceUID				fd;
	char				*p, path[FILE_PATH], file[FILE_PATH], sjis[FILE_PATH];
	DirList				FileList, FileList2, *DList = NULL, *DList2 = NULL;
	int					i, startX, startY;

	if (base) {
		strcpy(path, base);
	} else {
		strcpy(path, s2ch.cwDir);
	}
	DList = &FileList;											// ʏgp̃fBNgXg
	DList2 = &FileList2;										// ꎞޔp
	DList->count = psp2chMenuGetDir( path, &DList );
	strcpy(file, path);

	if(DList->count < 0) {
		return -1;
	}
	startX = 80;
	startY = 120;
	DList->pos = 0;

	ListDraw( DList, startX, startY, 100, 1 );
	while (!gExitRequest)
	{
		ListDraw( DList, startX, startY, 100, 0 );
		if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
		{
			psp2chCursorSet( &DList );
			if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
			{
				s2ch.oldPad = s2ch.pad;

				if (s2ch.pad.Buttons & (PSP_CTRL_CIRCLE | PSP_CTRL_RIGHT))	//  []
				{
					psp2chUTF82Sjis( sjis, DList->file[DList->pos].name );
					strcpy( file, path );
					strcat( file, "/" );
					strcat( file, sjis );
					if (DList->file[DList->pos].type == 1)
					{
						FileList2 = FileList;					// fBNgXgꎞޔ
						strcpy(path, file);
						DList->count = psp2chMenuGetDir( path, &DList );
						if (DList->count < 0){					// tH_ɃANZXoȂȂ烋[gɈړĂ݂
							p = strchr( path, ':' );
							if (p) {
								*(p+1) = '\0';
							} else {							// 肦ȂnY
								strcpy( path, "ms0:" );
							}
							if ((fd = sceIoDopen(path)) < 0) {
								deleteDirList( &DList2 );
								return -1;						// [gɃANZXoȂȂI
							}
							sceIoDclose(fd);
							DList->count = psp2chMenuGetDir( path, &DList );
							if (DList->count < 0) {				// ł͎sȂnY
								return -1;
								deleteDirList( &DList2 );
							}
						}
						DList->pos = 0;
						for (i=0; i<5; i++) {
							ListDraw( DList2, startX-i*10, startY, (5-i)*20, 0 );
							sceDisplayWaitVblankStart();
							flipScreen(0);
						}
						ListDraw( DList, startX, startY, 0, 2 );
						for (i=5; i>0; i--) {
							ListDraw( DList, startX+i*10, startY, (5-i)*20, 0 );
							sceDisplayWaitVblankStart();
							flipScreen(0);
						}
						deleteDirList( &DList2 );
					}
					else										// t@CʂƂ̓
					{
						doFile( path, file, DList );
						ListDraw( DList, startX, startY, 100, 1 );
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_LEFT)		// []
				{
					char	backDir[256];
					p = strrchr( path, '/' );
					if (p) {												// ݈ʒu[gȊȌꍇ
						FileList2 = FileList;								// fBNgXgꎞޔ
						psp2chSjis2UTF8( backDir, p+1 );					// ܂ŋtH_ۑ
						*p = '\0';											// Ԍɂ'/'̈ʒuȌ폜
						DList->count = psp2chMenuGetDir( path, &DList );	// fBNgꗗ̎擾
						if (DList->count < 0){								// tH_ɃANZXoȂȂ烋[gɈړĂ݂
							p = strchr( path, ':' );
							if (p) {
								*(p+1) = '\0';
							} else {										// 肦ȂnY
								strcpy( path, "ms0:" );
							}
							if ((fd = sceIoDopen(path)) < 0) {
								deleteDirList( &DList2 );
								return -1;									// [gɃANZXoȂȂI
							}
							sceIoDclose(fd);
							DList->count = psp2chMenuGetDir( path, &DList );
							if (DList->count < 0) {							// ł͎sȂnY
								deleteDirList( &DList2 );
								return -1;
							}
						}
						DList->pos = 0;										// ܂ŋtH_Ȃꍇ̃ftHg
						for (i=0; i<DList->count ;i++){						// ܂ŋtH_̏ɃJ[\Zbg
							if (!strcmp(backDir,DList->file[i].name)) {
								DList->pos = i;
							}
						}
						for (i=0; i<5; i++) {
							ListDraw( DList2, startX+i*10, startY, (5-i)*20, 0 );
							sceDisplayWaitVblankStart();
							flipScreen(0);
						}
						ListDraw( DList, startX, startY, 0, 2 );			// ʍXV
						for (i=5; i>0; i--) {
							ListDraw( DList, startX-i*10, startY, (5-i)*20, 0 );
							sceDisplayWaitVblankStart();
							flipScreen(0);
						}
						deleteDirList( &DList2 );
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_CROSS)		// ~
				{
					ListDraw( DList, startX, startY, 100, 1);
					sceGuSync(GU_SYNC_FINISH, GU_SYNC_WHAT_DONE);
					flipScreen(0);
					if (MessageDialogYesNo(FV_MESSAGE_END) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
						break;
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)	// 
				{
/*					DrawImg	*image;
					int		ret;
					image = ScreenCopy();						// ʃC[Wۑ
					psp2chUTF82Sjis( sjis, DList->file[DList->pos].name );
					ret = psp2chMenuFileCtrl( path, sjis, DList->file[DList->pos].type );
					ScreenPaste(image);							// ʃC[W𕜌
					flipScreen(0);
					if (ret){
						deleteDirList( &DList );
						DList->count = psp2chMenuGetDir( path, &DList );	// t@Czuω̂ōĎ擾
						if(DList->count < 0)
							return -1;
						if (DList->pos>=DList->count) DList->pos = DList->count - 1;
					}
*/				}

				else if(s2ch.pad.Buttons & PSP_CTRL_SQUARE)		// 
				{
					psp2chAudioStop();
					strcpy(file, path);
				}
			}
			sceDisplayWaitVblankStart();
			flipScreen(0);
		}
	}
	deleteDirList( &DList );
	return 0;
}

//==============================================================
// fBNg擾
//--------------------------------------------------------------
// file  :擾tH_iVtgJISj
// DList :tH_GgiUTF8j
// ߂l:Ggi-1:G[j
//--------------------------------------------------------------
// intraFontŕ\s֌WŁAVtgJISR[hx[XƃR[hϊɖł
// ȂԂ|Ă܂UTF8R[hx[XɕύXB
//--------------------------------------------------------------

static int psp2chMenuGetDir(char* file, DirList **DListPtr)
{
	SceUID		fd;
	SceIoDirent	dir;
	DirList		*DList;
	FileData	*FData, FDataBuf;
	int		i, j, count;
	char	*buf, path[1024], utf8[1024];

	DList = *DListPtr;

	strcpy( path, file );
	if (path[strlen(path)-1]=='\\') strcat(path,"\\");
	if ((fd = sceIoDopen(path)) < 0) {							// path̍Ō'\'Ƃȓc?
		psp2chNormalError( DIR_OPEN_ERR, file );
		return -1;
	}

	memset(&dir, 0, sizeof(dir));								// ȂreadɎs
	count = 0;
	while (sceIoDread(fd, &dir) > 0) {							// tH_Gg̃JEg
		if(strcmp(dir.d_name, ".") == 0 || strcmp(dir.d_name, "..") == 0) {
			continue;
		}
		count++;
	}
	sceIoDclose(fd);
	FData = (FileData*)malloc(sizeof(FileData) * count);		// GgXgpӂĂ
	if (FData == NULL) {
		sprintf( utf8, "%dbyte", sizeof(FileData) * count );
		psp2chNormalError( MEM_ALLC_ERR, utf8 );
		return -1;
	}
	if ((fd = sceIoDopen(path)) < 0) {							// ł͎sȂnY
		free(FData);
		psp2chNormalError( DIR_OPEN_ERR, file );
		return -1;
	}

	i = 0;
	memset(&dir, 0, sizeof(dir));
	while (sceIoDread(fd, &dir) > 0) {							// Gge擾
		if(strcmp(dir.d_name, ".") == 0 || strcmp(dir.d_name, "..") == 0) {
			continue;
		}
		if (s2ch.cfg.hbl) {
			strcpy( utf8, dir.d_name );
		} else {
			psp2chSjis2UTF8( utf8, dir.d_name );
		}
		buf = (char*)malloc(sizeof(char) * (strlen(utf8) + 1));
		if (buf==NULL) {										// ȂI
			count = i;											// 擾ł܂ł͗L
			break;
		}
		FData[i].name = buf;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNgHt@CH
			FData[i].type = 1;									// fBNg
		} else {
			FData[i].type = 0;									// t@C
		}
		strcpy( FData[i].name, utf8 );							// t@C
		FData[i].size = dir.d_stat.st_size;						// t@CTCY
		FData[i].mtime = dir.d_stat.st_mtime;					// ŏIANZX
		FData[i].thumb = NULL;									// TlC摜
		i++;
		if (i >= count) break;
	}
	sceIoDclose(fd);

	if (s2ch.cfg.fileSort) {									// t@Cz\[g
		for (i=0; i<count-1 ;i++) {
			for (j=i+1; j<count ;j++) {
				if ((strcmp(FData[i].name,FData[j].name)>0 && FData[i].type==FData[j].type)
				        || (!FData[i].type && FData[j].type)) {
					FDataBuf = FData[i];
					FData[i] = FData[j];
					FData[j] = FDataBuf;
				}
			}
		}
	}

	DList->file = FData;
	DList->count = count;
	DList->pos = 0;
	return count;
}


//==============================================================
// fBNg폜
//--------------------------------------------------------------
// w肳ꂽfBNgt@C܂߂č폜B
// ɂTufBNg폜܂B
//--------------------------------------------------------------

static void removeDir(char *path)
{
	SceIoDirent	dir;
	SceUID		fd;
	char		file[1024];

	if ((fd = sceIoDopen(path)) < 0) return;					// wfBNgJȂ̂ŏI
	memset(&dir, 0, sizeof(dir));								// ȂreadɎs
	while (sceIoDread(fd, &dir) > 0){
		if(strcmp(dir.d_name, ".") == 0) continue;
		if(strcmp(dir.d_name, "..") == 0) continue;
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, dir.d_name );
		if (dir.d_stat.st_attr & FIO_SO_IFDIR){					// fBNgHt@CH
			removeDir(file);									// fBNgiċAŃTufBNgj
		} else {
			sceIoRemove(file);									// t@C
		}
	}
	sceIoDclose(fd);
	sceIoRmdir(path);
}

/****************
t@C
****************/
#define FILE_CTRL_WIDTH (80)
#define FILE_CTRL_ITEM (6)
static int psp2chMenuFileCtrl(char* path, char* name, int status)
{
	static int mode = 0; // Rs[Cړ̃[h
	static char mpath[FILE_PATH], mname[FILE_PATH]; // ̏ꏊ
    const char* menuList[] = {"Rs[", "ړ", "y[Xg", "l[", "폜","ŊJ"};
    const char title1[] = "Vt@C͂Ă";
    const char *text = "Vt@C";
    SceUID fd, dst;
    char file[FILE_PATH], old[FILE_PATH], buf[BUF_LENGTH];
    int lineEnd = FILE_CTRL_ITEM, change = 1, size;
    int startX, startY, scrX, scrY,CHflag;

//	menu.count = FILE_CTRL_ITEM;
    startX = 350;
    startY = 100;
    scrX = FILE_CTRL_WIDTH;
    scrY = FONTPITCH * lineEnd;
/*    menu.start = 0;
    menu.select = 0;
    if (menu.select >= FILE_CTRL_ITEM)
    {
        menu.start = menu.select - FILE_CTRL_ITEM + 1;
    }
    
*/    CHflag = 0;													// t@CzɕύXHi0:Noj
    while (!gExitRequest)
    {
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
        	if (change)
			{
//	            psp2chDrawMenu((char**)menuList, menu, startX, startY, scrX, scrY);
			}
//            psp2chCursorSet(&menu);
            if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
            {
                s2ch.oldPad = s2ch.pad;
                if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
                {
//                    switch (menu.select)
                    switch (0)
                    {
                	case 0:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 1;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                    	break;
                    case 1:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 2;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                        break;
                    case 2:
                    	if(!mode)
                    		break;
                    	sprintf(old, "%s/%s", mpath, mname);
                    	sprintf(file, "%s/%s", path, mname);
                    	if((fd = sceIoOpen(old, PSP_O_RDONLY, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, old);
                    		break;
                    	}
                    	if((dst = sceIoOpen(file, PSP_O_WRONLY | PSP_O_CREAT, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, file);
                    		sceIoClose(fd);
                    		break;
                    	}
                    	while((size = psp2chFileRead(fd, buf, sizeof(buf))) > 0)
                    	{
	                    	psp2chFileWrite(dst, buf, size);
	                    }
	                    sceIoClose(fd);
	                    sceIoClose(dst);
						CHflag = -1;							// t@CzɕύX
	                    if(mode == 2)
	                    {
	                    	sceIoRemove(old);
	                    	strcpy(mpath, "");
	                    	strcpy(mname, "");
	                    }
	                    mode = 0;
                        break;
                    case 3:
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, name);
						} else {
							strcpy(buf, name);
						}
						if(psp2chInputDialog((char*)title1, (char*)text, buf) == 0 && keyWords[0])
						{
							char	utf8[128];
							sprintf(old, "%s/%s", path, name);
							if (s2ch.cfg.hbl){
								psp2chSjis2UTF8(utf8, keyWords);
								sprintf(file, "%s/%s", path, utf8);
							} else {
								sprintf(file, "%s/%s", path, keyWords);
							}
							sceIoRename(old, file);
							CHflag = -1;						// t@CzɕύX
						}
                        break;
                    case 4:										// 폜
						sprintf(file, "%s/%s", path, name);
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, file);
						} else {
							strcpy(buf, file);
						}
						if (status){							// ΏۂfBNg
							if (MessageDialogYesNo("%s\n̓tH_ł\nt@CiTutH_܂ށj܂߂č폜܂낵ł", 
											buf) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
								removeDir(file);
								CHflag = -1;					// t@CzɕύX
							}
						} else {								// Ώۂt@C
							if (MessageDialogYesNo("%s\n%s", buf, "̃t@C폜܂") == PSP_UTILITY_MSGDIALOG_RESULT_YES)
							{
								sceIoRemove(file);
								CHflag = -1;					// t@CzɕύX
							}
						}
                    	break;
                    case 5:										// ŊJ
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
						sprintf(file, "%s/%s", path, name);
						SMEMOfile( file );						// wt@CPSPŊJ
						break;
                    }
					change = 1;
                    break;
                }
                else if (s2ch.pad.Buttons & PSP_CTRL_CROSS)
                {
                    break;
                }
            }
			
			flipScreen(0);
        }
    }
    return CHflag;
}

