//==============================================================
// PSPVXe_CAO֘A
//--------------------------------------------------------------

#include <stdio.h>
#include <stdarg.h>
#include "pspdialogs.h"
#include "FreezeViewer.h"
#include "charConv.h"
#include "fvDraw.h"


//==============================================================
// ʍXV
//--------------------------------------------------------------

void minimalRender()
{
	guStart();
	sceGuScissor( 0, 0, SCR_WIDTH, SCR_HEIGHT );
	sceGuClearDepth(0);
	sceGuClear( GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT );
	sceGuFinish();
	sceGuSync( 0, 0 );
}

//==============================================================
// G[_CAO̕\
//--------------------------------------------------------------

void pspShowErrorDialog(const int error, u8 language)
{
	pspUtilityMsgDialogParams	dialog;
	SceSize						dialog_size = sizeof(dialog);
	int	done = 0;

	memset( &dialog, 0, dialog_size );
	dialog.base.size = dialog_size;
	if (language == DIALOG_LANGUAGE_AUTO) {
		sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &dialog.base.language );
	} else {
		dialog.base.language = language;
	}
	sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &dialog.base.buttonSwap );
	dialog.base.graphicsThread = 0x11;
	dialog.base.accessThread = 0x13;
	dialog.base.fontThread = 0x12;
	dialog.base.soundThread = 0x10;
	//dialog.unknown2[1] = 0;
	//dialog.unknown2[2] = error;
	dialog.mode = PSP_UTILITY_MSGDIALOG_MODE_ERROR;
	dialog.errorValue = error;

	ScreenCopy2();												// wiޔ
	sceUtilityMsgDialogInitStart(&dialog);

	while (!done) {
		minimalRender();
		ScreenPaste2();

		switch (sceUtilityMsgDialogGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE:
				break;
			case PSP_UTILITY_DIALOG_INIT :
				break;
			case PSP_UTILITY_DIALOG_VISIBLE:
				sceUtilityMsgDialogUpdate(2);
				sceDisplayWaitVblankStart();
				break;
			case PSP_UTILITY_DIALOG_QUIT:
				sceUtilityMsgDialogShutdownStart();
				break;
			case PSP_UTILITY_DIALOG_FINISHED :
				done = 1;
				break;
		}
		sceDisplayWaitVblankStart();
		flipScreen(0);
	}
}

//==============================================================
// bZ[W_CAO̕\
//--------------------------------------------------------------

void pspShowMessageDialog(MESSAGE_HELPER *mh, u8 language)
{
	pspUtilityMsgDialogParams	dialog;
	SceSize						dialog_size = sizeof(dialog);
	int	done=0;

	memset( &dialog, 0, dialog_size );
	dialog.base.size = dialog_size;
	if (language == DIALOG_LANGUAGE_AUTO) {
		sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &dialog.base.language );
	} else {
		dialog.base.language = language;
	}
	sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &dialog.base.buttonSwap );
	dialog.base.graphicsThread = 0x11;
	dialog.base.accessThread = 0x13;
	dialog.base.fontThread = 0x12;
	dialog.base.soundThread = 0x10;
	//dialog.unknown2[1] = 1;
	dialog.mode = PSP_UTILITY_MSGDIALOG_MODE_TEXT;
	strcpy(dialog.message, mh->message);
	dialog.options = mh->options;

	ScreenCopy2();												// wiޔ
	sceUtilityMsgDialogInitStart(&dialog);

	while (!done && !gExitRequest) {
		minimalRender();
		ScreenPaste2();

		switch (sceUtilityMsgDialogGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE:
				break;
			case PSP_UTILITY_DIALOG_INIT:
				break;
			case PSP_UTILITY_DIALOG_VISIBLE:
				sceUtilityMsgDialogUpdate(2);
				sceDisplayWaitVblankStart();
				break;
			case PSP_UTILITY_DIALOG_QUIT:
				sceUtilityMsgDialogShutdownStart();
				break;
			case PSP_UTILITY_DIALOG_FINISHED :
				done = 1;
				break;
		}
		sceDisplayWaitVblankStart();
		flipScreen(0);
	}
	mh->result = dialog.base.result;
	mh->buttonPressed = dialog.buttonPressed;
}

//==============================================================
// bZ[W_CAŐNiYes/Noj
//--------------------------------------------------------------
// fmt:\郁bZ[WiVtgJIS asciizj
// ߂l 0:UNKNOWN1
//        1:YES
//        2:NO
//        3:BACK
//--------------------------------------------------------------

int MessageDialogYesNo(char *fmt, ...)
{
	MESSAGE_HELPER	mh;
	va_list			list;
	char			msg[1024];

	va_start( list, fmt );
	vsprintf( msg, fmt, list );
	va_end( list );

	psp2chSjis2UTF8( mh.message, msg );
	mh.options = PSP_UTILITY_MSGDIALOG_OPTION_YESNO_BUTTONS | PSP_UTILITY_MSGDIALOG_OPTION_DEFAULT_NO;
	pspShowMessageDialog( &mh, PSP_SYSTEMPARAM_LANGUAGE_JAPANESE );
	return mh.buttonPressed;
}

//==============================================================
// bZ[W_CAŐNi߂j
//--------------------------------------------------------------
// msg:\郁bZ[WiVtgJIS asciizj
// ߂l 3:BACK
//--------------------------------------------------------------

int MessageDialogText(char *fmt, ...)
{
	MESSAGE_HELPER	mh;
	va_list			list;
	char			msg[1024];

	va_start( list, fmt );
	vsprintf( msg, fmt, list );
	va_end( list );

	psp2chSjis2UTF8( mh.message, msg );
	mh.options = PSP_UTILITY_MSGDIALOG_OPTION_TEXT;
	pspShowMessageDialog( &mh, PSP_SYSTEMPARAM_LANGUAGE_JAPANESE );
	return mh.buttonPressed;
}
